--- old/usr/src/cmd/zonestat/zonestatd/zonestatd.c	Wed Oct  5 00:31:44 2016
+++ new/usr/src/cmd/zonestat/zonestatd/zonestatd.c	Wed Oct  5 00:31:44 2016
@@ -21,6 +21,7 @@
 
 /*
  * Copyright (c) 2010, Oracle and/or its affiliates. All rights reserved.
+ * Copyright (c) 2011, Joyent, Inc. All rights reserved.
  */
 #include <alloca.h>
 #include <assert.h>
@@ -2190,7 +2191,7 @@
 	return (rctlblk_get_value(rblk));
 }
 
-#define	ZSD_NUM_RCTL_VALS 19
+#define	ZSD_NUM_RCTL_VALS 20
 
 /*
  * Fetch the limit information for a zone.  This uses zone_enter() as the
@@ -2237,12 +2238,6 @@
 	*msgids = 0;
 	*lofi = 0;
 
-	/* Get the ram cap first since it is a zone attr */
-	ret = zone_getattr(zone->zsz_id, ZONE_ATTR_PHYS_MCAP,
-	    ram_cap, sizeof (*ram_cap));
-	if (ret < 0 || *ram_cap == 0)
-		*ram_cap = ZS_LIMIT_NONE;
-
 	/* Get the zone's default scheduling class */
 	ret = zone_getattr(zone->zsz_id, ZONE_ATTR_SCHED_CLASS,
 	    class, sizeof (class));
@@ -2298,6 +2293,7 @@
 		vals[i++] = zsd_get_zone_rctl_usage("zone.max-msg-ids");
 		vals[i++] = zsd_get_zone_rctl_limit("zone.max-lofi");
 		vals[i++] = zsd_get_zone_rctl_usage("zone.max-lofi");
+		vals[i++] = zsd_get_zone_rctl_usage("zone.max-physical-memory");
 
 		if (write(p[1], vals, ZSD_NUM_RCTL_VALS * sizeof (uint64_t)) !=
 		    ZSD_NUM_RCTL_VALS * sizeof (uint64_t)) {
@@ -2342,6 +2338,7 @@
 	*msgids = vals[i++];
 	*lofi_cap = vals[i++];
 	*lofi = vals[i++];
+	*ram_cap = vals[i++];
 
 	/* Interpret maximum values as no cap */
 	if (*cpu_cap == UINT32_MAX || *cpu_cap == 0)
--- /dev/null	Wed Oct  5 00:31:44 2016
+++ new/usr/src/common/brand/lx/lx_auxv.c	Wed Oct  5 00:31:44 2016
@@ -0,0 +1,96 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2016 Joyent, Inc.
+ */
+
+#include <sys/auxv.h>
+#include <sys/lx_brand.h>
+
+/*
+ * Linux does not make the distinction between 'int' and 'long' when it comes
+ * to the format of the aux vector.  In order to properly clear the struct
+ * padding present in the native auxv_t in 64-bit, we employ the Linux format.
+ */
+struct lx_auxv {
+	long la_type;
+	long la_val;
+};
+
+int
+lx_auxv_stol(const auxv_t *ap, auxv_t *oap, const lx_elf_data_t *edp)
+{
+	struct lx_auxv *loap = (struct lx_auxv *)oap;
+
+	switch (ap->a_type) {
+	case AT_BASE:
+		loap->la_val = edp->ed_base;
+		break;
+	case AT_ENTRY:
+		loap->la_val = edp->ed_entry;
+		break;
+	case AT_PHDR:
+		loap->la_val = edp->ed_phdr;
+		break;
+	case AT_PHENT:
+		loap->la_val = edp->ed_phent;
+		break;
+	case AT_PHNUM:
+		loap->la_val = edp->ed_phnum;
+		break;
+	case AT_SUN_BRAND_LX_SYSINFO_EHDR:
+		loap->la_type = AT_SYSINFO_EHDR;
+		loap->la_val = ap->a_un.a_val;
+		return (0);
+	case AT_SUN_BRAND_LX_CLKTCK:
+		loap->la_type = AT_CLKTCK;
+		loap->la_val = ap->a_un.a_val;
+		return (0);
+	case AT_SUN_AUXFLAGS:
+		if ((ap->a_un.a_val & AF_SUN_SETUGID) != 0) {
+			loap->la_type = AT_SECURE;
+			loap->la_val = 1;
+			return (0);
+		} else {
+			return (1);
+		}
+	case AT_SUN_GID:
+		loap->la_type = AT_LX_EGID;
+		loap->la_val = ap->a_un.a_val;
+		return (0);
+	case AT_SUN_RGID:
+		loap->la_type = AT_LX_GID;
+		loap->la_val = ap->a_un.a_val;
+		return (0);
+	case AT_SUN_UID:
+		loap->la_type = AT_LX_EUID;
+		loap->la_val = ap->a_un.a_val;
+		return (0);
+	case AT_SUN_RUID:
+		loap->la_type = AT_LX_UID;
+		loap->la_val = ap->a_un.a_val;
+		return (0);
+	case AT_EXECFD:
+	case AT_PAGESZ:
+	case AT_FLAGS:
+	case AT_RANDOM:
+	case AT_NULL:
+		/* No translate needed */
+		loap->la_val = ap->a_un.a_val;
+		break;
+	default:
+		/* All other unrecognized entries are ignored */
+		return (1);
+	}
+	loap->la_type = ap->a_type;
+	return (0);
+}
--- /dev/null	Wed Oct  5 00:31:44 2016
+++ new/usr/src/common/brand/lx/lx_auxv.h	Wed Oct  5 00:31:44 2016
@@ -0,0 +1,32 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2015 Joyent, Inc.
+ */
+
+#ifndef	_LX_AUXV_H
+#define	_LX_AUXV_H
+
+#include <sys/auxv.h>
+#include <sys/lx_brand.h>
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+extern int lx_auxv_stol(const auxv_t *, auxv_t *, const lx_elf_data_t *);
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif	/* _LX_AUXV_H */
--- /dev/null	Wed Oct  5 00:31:44 2016
+++ new/usr/src/common/brand/lx/lx_errno.h	Wed Oct  5 00:31:44 2016
@@ -0,0 +1,29 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2015 Joyent, Inc.
+ */
+
+#ifndef _LX_ERRNO_H
+#define	_LX_ERRNO_H
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+extern int lx_errno(int, int);
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* _LX_ERRNO_H */
--- /dev/null	Wed Oct  5 00:31:44 2016
+++ new/usr/src/common/brand/lx/lx_signum.c	Wed Oct  5 00:31:44 2016
@@ -0,0 +1,339 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ * Copyright 2015 Joyent, Inc.
+ */
+
+#include <sys/signal.h>
+#include <sys/lx_siginfo.h>
+#include <lx_signum.h>
+#include <sys/debug.h>
+
+/*
+ * Delivering signals to a Linux process is complicated by differences in
+ * signal numbering, stack structure and contents, and the action taken when a
+ * signal handler exits.  In addition, many signal-related structures, such as
+ * sigset_ts, vary between Solaris and Linux.
+ *
+ * The simplest transformation that must be done when sending signals is to
+ * translate between Linux and Solaris signal numbers.
+ *
+ * These are the major signal number differences between Linux and Solaris:
+ *
+ * 	====================================
+ * 	| Number |   Linux    |  Solaris   |
+ * 	| ====== | =========  | ========== |
+ *	|    7   | SIGBUS     | SIGEMT     |
+ *	|   10   | SIGUSR1    | SIGBUS     |
+ *	|   12   | SIGUSR2    | SIGSYS     |
+ *	|   16   | SIGSTKFLT  | SIGUSR1    |
+ *	|   17   | SIGCHLD    | SIGUSR2    |
+ * 	|   18   | SIGCONT    | SIGCHLD    |
+ *	|   19   | SIGSTOP    | SIGPWR     |
+ * 	|   20   | SIGTSTP    | SIGWINCH   |
+ * 	|   21   | SIGTTIN    | SIGURG     |
+ * 	|   22   | SIGTTOU    | SIGPOLL    |
+ *	|   23   | SIGURG     | SIGSTOP    |
+ * 	|   24   | SIGXCPU    | SIGTSTP    |
+ *	|   25   | SIGXFSZ    | SIGCONT    |
+ *	|   26   | SIGVTALARM | SIGTTIN    |
+ *	|   27   | SIGPROF    | SIGTTOU    |
+ *	|   28   | SIGWINCH   | SIGVTALARM |
+ *	|   29   | SIGPOLL    | SIGPROF    |
+ *	|   30   | SIGPWR     | SIGXCPU    |
+ *	|   31   | SIGSYS     | SIGXFSZ    |
+ * 	====================================
+ *
+ * Not every Linux signal maps to a Solaris signal, nor does every Solaris
+ * signal map to a Linux counterpart. However, when signals do map, the
+ * mapping is unique.
+ *
+ * One mapping issue is that Linux supports 33 real time signals, with SIGRTMIN
+ * typically starting at or near 32 (SIGRTMIN) and proceeding to 64 (SIGRTMAX)
+ * (SIGRTMIN is "at or near" 32 because glibc usually "steals" one ore more of
+ * these signals for its own internal use, adjusting SIGRTMIN and SIGRTMAX as
+ * needed.)  Conversely, Solaris actively uses signals 32-40 for other purposes
+ * and supports exactly 32 real time signals, in the range 41 (SIGRTMIN)
+ * to 72 (SIGRTMAX).
+ *
+ * At present, attempting to translate a Linux signal equal to 63
+ * will generate an error (we allow SIGRTMAX because a program
+ * should be able to send SIGRTMAX without getting an EINVAL, though obviously
+ * anything that loops through the signals from SIGRTMIN to SIGRTMAX will
+ * fail.)
+ *
+ * Similarly, attempting to translate a native Solaris signal in the range
+ * 32-40 will also generate an error as we don't want to support the receipt of
+ * those signals from the Solaris global zone.
+ */
+
+/*
+ * Linux to Solaris signal map
+ *
+ * Usage:  solaris_signal = ltos_signum[lx_signal];
+ */
+const int
+ltos_signo[LX_NSIG + 1] = {
+	0,
+	SIGHUP,
+	SIGINT,
+	SIGQUIT,
+	SIGILL,
+	SIGTRAP,
+	SIGABRT,
+	SIGBUS,
+	SIGFPE,
+	SIGKILL,
+	SIGUSR1,
+	SIGSEGV,
+	SIGUSR2,
+	SIGPIPE,
+	SIGALRM,
+	SIGTERM,
+	SIGEMT,			/* 16:  Linux SIGSTKFLT; use Solaris SIGEMT */
+	SIGCHLD,
+	SIGCONT,
+	SIGSTOP,
+	SIGTSTP,
+	SIGTTIN,
+	SIGTTOU,
+	SIGURG,
+	SIGXCPU,
+	SIGXFSZ,
+	SIGVTALRM,
+	SIGPROF,
+	SIGWINCH,
+	SIGPOLL,
+	SIGPWR,
+	SIGSYS,
+	_SIGRTMIN,		/* 32:  Linux SIGRTMIN */
+	_SIGRTMIN + 1,
+	_SIGRTMIN + 2,
+	_SIGRTMIN + 3,
+	_SIGRTMIN + 4,
+	_SIGRTMIN + 5,
+	_SIGRTMIN + 6,
+	_SIGRTMIN + 7,
+	_SIGRTMIN + 8,
+	_SIGRTMIN + 9,
+	_SIGRTMIN + 10,
+	_SIGRTMIN + 11,
+	_SIGRTMIN + 12,
+	_SIGRTMIN + 13,
+	_SIGRTMIN + 14,
+	_SIGRTMIN + 15,
+	_SIGRTMIN + 16,
+	_SIGRTMIN + 17,
+	_SIGRTMIN + 18,
+	_SIGRTMIN + 19,
+	_SIGRTMIN + 20,
+	_SIGRTMIN + 21,
+	_SIGRTMIN + 22,
+	_SIGRTMIN + 23,
+	_SIGRTMIN + 24,
+	_SIGRTMIN + 25,
+	_SIGRTMIN + 26,
+	_SIGRTMIN + 27,
+	_SIGRTMIN + 28,
+	_SIGRTMIN + 29,
+	_SIGRTMIN + 30,
+	_SIGRTMIN + 31,
+	_SIGRTMAX,		/* 64:  Linux SIGRTMAX */
+};
+
+/*
+ * Solaris to Linux signal map
+ *
+ * Usage:  lx_signal = stol_signo[solaris_signal];
+ */
+const int
+stol_signo[NSIG] = {
+	0,
+	LX_SIGHUP,
+	LX_SIGINT,
+	LX_SIGQUIT,
+	LX_SIGILL,
+	LX_SIGTRAP,
+	LX_SIGABRT,
+	LX_SIGSTKFLT,		/* 7:  Solaris SIGEMT; use for LX_SIGSTKFLT */
+	LX_SIGFPE,
+	LX_SIGKILL,
+	LX_SIGBUS,
+	LX_SIGSEGV,
+	LX_SIGSYS,
+	LX_SIGPIPE,
+	LX_SIGALRM,
+	LX_SIGTERM,
+	LX_SIGUSR1,
+	LX_SIGUSR2,
+	LX_SIGCHLD,
+	LX_SIGPWR,
+	LX_SIGWINCH,
+	LX_SIGURG,
+	LX_SIGPOLL,
+	LX_SIGSTOP,
+	LX_SIGTSTP,
+	LX_SIGCONT,
+	LX_SIGTTIN,
+	LX_SIGTTOU,
+	LX_SIGVTALRM,
+	LX_SIGPROF,
+	LX_SIGXCPU,
+	LX_SIGXFSZ,
+	-1,			/* 32:  Solaris SIGWAITING */
+	-1,			/* 33:  Solaris SIGLWP */
+	-1,			/* 34:  Solaris SIGFREEZE */
+	-1,			/* 35:  Solaris SIGTHAW */
+	-1,			/* 36:  Solaris SIGCANCEL */
+	-1,			/* 37:  Solaris SIGLOST */
+	-1,			/* 38:  Solaris SIGXRES */
+	-1,			/* 39:  Solaris SIGJVM1 */
+	-1,			/* 40:  Solaris SIGJVM2 */
+	-1,			/* 41:  Solaris SIGINFO */
+	LX_SIGRTMIN,		/* 42:  Solaris _SIGRTMIN */
+	LX_SIGRTMIN + 1,
+	LX_SIGRTMIN + 2,
+	LX_SIGRTMIN + 3,
+	LX_SIGRTMIN + 4,
+	LX_SIGRTMIN + 5,
+	LX_SIGRTMIN + 6,
+	LX_SIGRTMIN + 7,
+	LX_SIGRTMIN + 8,
+	LX_SIGRTMIN + 9,
+	LX_SIGRTMIN + 10,
+	LX_SIGRTMIN + 11,
+	LX_SIGRTMIN + 12,
+	LX_SIGRTMIN + 13,
+	LX_SIGRTMIN + 14,
+	LX_SIGRTMIN + 15,
+	LX_SIGRTMIN + 16,
+	LX_SIGRTMIN + 17,
+	LX_SIGRTMIN + 18,
+	LX_SIGRTMIN + 19,
+	LX_SIGRTMIN + 20,
+	LX_SIGRTMIN + 21,
+	LX_SIGRTMIN + 22,
+	LX_SIGRTMIN + 23,
+	LX_SIGRTMIN + 24,
+	LX_SIGRTMIN + 25,
+	LX_SIGRTMIN + 26,
+	LX_SIGRTMIN + 27,
+	LX_SIGRTMIN + 28,
+	LX_SIGRTMIN + 29,
+	LX_SIGRTMIN + 30,
+	LX_SIGRTMIN + 31,
+	LX_SIGRTMAX,		/* 74: Solaris _SIGRTMAX */
+};
+
+/*
+ * Convert an illumos native signal number to a Linux signal number and return
+ * it.  If no valid conversion is possible, the function fails back to the
+ * value of "defsig".  In userland, passing a default signal number of "-1"
+ * will abort the program if the signal number could not be converted.
+ */
+int
+lx_stol_signo(int signo, int defsig)
+{
+	int rval;
+
+#ifdef	_KERNEL
+	VERIFY3S(defsig, >=, 0);
+#endif
+
+	if (signo < 0 || signo >= NSIG || (rval = stol_signo[signo]) < 1) {
+#ifndef	_KERNEL
+		VERIFY3S(defsig, >=, 0);
+#endif
+		return (defsig);
+	}
+
+	return (rval);
+}
+
+
+/*
+ * Convert a Linux signal number to an illumos signal number and return it.
+ * Error behavior is identical to lx_stol_signo.
+ */
+int
+lx_ltos_signo(int signo, int defsig)
+{
+#ifdef	_KERNEL
+	VERIFY3S(defsig, >=, 0);
+#endif
+
+	if (signo < 1 || signo >= NSIG) {
+#ifndef	_KERNEL
+		VERIFY3S(defsig, >=, 0);
+#endif
+		return (defsig);
+	}
+
+	return (ltos_signo[signo]);
+}
+
+/*
+ * Convert the "status" field of a SIGCLD siginfo_t.  We need to extract the
+ * illumos signal number and convert it to a Linux signal number while leaving
+ * the ptrace(2) event bits intact.  In userland, passing a default signal
+ * number of "-1" will abort the program if the signal number could not be
+ * converted, as for lx_stol_signo().
+ */
+int
+lx_stol_status(int s, int defsig)
+{
+	/*
+	 * We mask out the top bit here in case PTRACE_O_TRACESYSGOOD
+	 * is in use and 0x80 has been ORed with the signal number.
+	 */
+	int stat = lx_stol_signo(s & 0x7f, defsig);
+
+	/*
+	 * We must mix in the ptrace(2) event which may be stored in
+	 * the second byte of the status code.  We also re-include the
+	 * PTRACE_O_TRACESYSGOOD bit.
+	 */
+	return ((s & 0xff80) | stat);
+}
+
+int
+lx_stol_sigcode(int code)
+{
+	switch (code) {
+	case SI_USER:
+		return (LX_SI_USER);
+	case SI_LWP:
+		return (LX_SI_TKILL);
+	case SI_QUEUE:
+		return (LX_SI_QUEUE);
+	case SI_TIMER:
+		return (LX_SI_TIMER);
+	case SI_ASYNCIO:
+		return (LX_SI_ASYNCIO);
+	case SI_MESGQ:
+		return (LX_SI_MESGQ);
+	default:
+		return (code);
+	}
+}
--- /dev/null	Wed Oct  5 00:31:44 2016
+++ new/usr/src/common/brand/lx/lx_signum.h	Wed Oct  5 00:31:44 2016
@@ -0,0 +1,114 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+/*
+ * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ * Copyright 2015 Joyent, Inc.
+ */
+
+#ifndef _LX_SIGNUM_H
+#define	_LX_SIGNUM_H
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+#define	LX_SIGHUP	1
+#define	LX_SIGINT	2
+#define	LX_SIGQUIT	3
+#define	LX_SIGILL	4
+#define	LX_SIGTRAP	5
+#define	LX_SIGABRT	6
+#define	LX_SIGIOT	6
+#define	LX_SIGBUS	7
+#define	LX_SIGFPE	8
+#define	LX_SIGKILL	9
+#define	LX_SIGUSR1	10
+#define	LX_SIGSEGV	11
+#define	LX_SIGUSR2	12
+#define	LX_SIGPIPE	13
+#define	LX_SIGALRM	14
+#define	LX_SIGTERM	15
+#define	LX_SIGSTKFLT	16
+#define	LX_SIGCHLD	17
+#define	LX_SIGCONT	18
+#define	LX_SIGSTOP	19
+#define	LX_SIGTSTP	20
+#define	LX_SIGTTIN	21
+#define	LX_SIGTTOU	22
+#define	LX_SIGURG	23
+#define	LX_SIGXCPU	24
+#define	LX_SIGXFSZ	25
+#define	LX_SIGVTALRM	26
+#define	LX_SIGPROF	27
+#define	LX_SIGWINCH	28
+#define	LX_SIGIO	29
+#define	LX_SIGPOLL	LX_SIGIO
+#define	LX_SIGPWR	30
+#define	LX_SIGSYS	31
+#define	LX_SIGUNUSED	31
+
+#define	LX_NSIG		64	/* Linux _NSIG */
+
+#define	LX_SIGRTMIN	32
+#define	LX_SIGRTMAX	LX_NSIG
+
+extern const int ltos_signo[];
+extern const int stol_signo[];
+
+extern int lx_stol_signo(int, int);
+extern int lx_ltos_signo(int, int);
+extern int lx_stol_status(int, int);
+extern int lx_stol_sigcode(int);
+
+/*
+ * NOTE:  Linux uses different definitions for 'sigset_t's and 'sigaction_t's
+ *	  depending on whether the definition is for user space or the kernel.
+ *
+ *	  The definitions below MUST correspond to the Linux kernel versions,
+ *	  as glibc will do the necessary translation from the Linux user
+ *	  versions.
+ */
+#if defined(_LP64)
+#define	LX_NSIG_WORDS	1
+#define	LX_WSHIFT	6
+#elif defined(_ILP32)
+#define	LX_NSIG_WORDS	2
+#define	LX_WSHIFT	5
+#else
+#error "LX only supports LP64 and ILP32"
+#endif
+
+typedef struct {
+	ulong_t	__bits[LX_NSIG_WORDS];
+} lx_sigset_t;
+
+#define	LX_NBITS		(sizeof (ulong_t) * NBBY)
+#define	lx_sigmask(n)		(1UL << (((n) - 1) % LX_NBITS))
+#define	lx_sigword(n)		(((ulong_t)((n) - 1)) >> LX_WSHIFT)
+#define	lx_sigismember(s, n)	(lx_sigmask(n) & (s)->__bits[lx_sigword(n)])
+#define	lx_sigaddset(s, n)	((s)->__bits[lx_sigword(n)] |= lx_sigmask(n))
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif	/* _LX_SIGNUM_H */
--- /dev/null	Wed Oct  5 00:31:44 2016
+++ new/usr/src/common/brand/lx/lx_syscall.h	Wed Oct  5 00:31:44 2016
@@ -0,0 +1,95 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2015 Joyent, Inc.
+ */
+
+#ifndef	_LX_SYSCALL_H
+#define	_LX_SYSCALL_H
+
+#include <sys/lx_brand.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+/*
+ * The br_scall_args field of lx_lwp_data is going to be populated with
+ * pointers to structs. The types of these structs should be defined in this
+ * header file.  These are Linux specific arguments to system calls that don't
+ * exist in illumos. Each section should be labelled with which system call it
+ * belongs to.
+ */
+
+/* arguments for waitpid(2) */
+/* see comments in usr/src/lib/brand/lx/lx_brand/common/wait.c */
+#define	LX_WNOTHREAD	0x20000000 /* Do not wait on siblings' children */
+#define	LX_WALL		0x40000000 /* Wait on all children */
+#define	LX_WCLONE	0x80000000 /* Wait only on clone children */
+
+/* For arch_prctl(2) */
+#define	LX_ARCH_SET_GS	0x1001
+#define	LX_ARCH_SET_FS	0x1002
+#define	LX_ARCH_GET_FS	0x1003
+#define	LX_ARCH_GET_GS	0x1004
+
+/*
+ * For ptrace(2):
+ */
+#define	LX_PTRACE_TRACEME	0
+#define	LX_PTRACE_PEEKTEXT	1
+#define	LX_PTRACE_PEEKDATA	2
+#define	LX_PTRACE_PEEKUSER	3
+#define	LX_PTRACE_POKETEXT	4
+#define	LX_PTRACE_POKEDATA	5
+#define	LX_PTRACE_POKEUSER	6
+#define	LX_PTRACE_CONT		7
+#define	LX_PTRACE_KILL		8
+#define	LX_PTRACE_SINGLESTEP	9
+#define	LX_PTRACE_GETREGS	12
+#define	LX_PTRACE_SETREGS	13
+#define	LX_PTRACE_GETFPREGS	14
+#define	LX_PTRACE_SETFPREGS	15
+#define	LX_PTRACE_ATTACH	16
+#define	LX_PTRACE_DETACH	17
+#define	LX_PTRACE_GETFPXREGS	18
+#define	LX_PTRACE_SETFPXREGS	19
+#define	LX_PTRACE_SYSCALL	24
+#define	LX_PTRACE_SETOPTIONS	0x4200
+#define	LX_PTRACE_GETEVENTMSG	0x4201
+#define	LX_PTRACE_GETSIGINFO	0x4202
+
+/*
+ * For clone(2):
+ */
+#define	LX_CSIGNAL		0x000000ff
+#define	LX_CLONE_VM		0x00000100
+#define	LX_CLONE_FS		0x00000200
+#define	LX_CLONE_FILES		0x00000400
+#define	LX_CLONE_SIGHAND	0x00000800
+#define	LX_CLONE_PID		0x00001000
+#define	LX_CLONE_PTRACE		0x00002000
+#define	LX_CLONE_VFORK		0x00004000
+#define	LX_CLONE_PARENT		0x00008000
+#define	LX_CLONE_THREAD		0x00010000
+#define	LX_CLONE_SYSVSEM	0x00040000
+#define	LX_CLONE_SETTLS		0x00080000
+#define	LX_CLONE_PARENT_SETTID	0x00100000
+#define	LX_CLONE_CHILD_CLEARTID	0x00200000
+#define	LX_CLONE_DETACH		0x00400000
+#define	LX_CLONE_CHILD_SETTID	0x01000000
+
+#ifdef	__cplusplus
+}
+#endif
+
+#endif	/* _LX_SYSCALL_H */
--- /dev/null	Wed Oct  5 00:31:44 2016
+++ new/usr/src/common/brand/lx/tools/Makefile	Wed Oct  5 00:31:44 2016
@@ -0,0 +1,42 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright 2015 Joyent, Inc.
+#
+
+PROG =			gen_errno
+
+include ../../../../cmd/Makefile.cmd
+
+OBJS =			gen_errno.o
+
+CLOBBERFILES +=		$(PROG)
+
+NATIVECC_CFLAGS +=	$(CFLAGS) $(CCVERBOSE)
+NATIVECC_LDLIBS +=	-lcmdutils -lnvpair
+
+.KEEP_STATE:
+
+all: $(PROG)
+
+install: all
+
+lint:	lint_PROG
+
+clean:
+	$(RM) $(OBJS)
+
+$(PROG): $(OBJS)
+	$(NATIVECC) $(NATIVECC_CFLAGS) $(NATIVECC_LDLIBS) $(OBJS) -o $@
+	$(POST_PROCESS)
+
+include ../../../../cmd/Makefile.targ
--- /dev/null	Wed Oct  5 00:31:45 2016
+++ new/usr/src/common/brand/lx/tools/gen_errno.c	Wed Oct  5 00:31:45 2016
@@ -0,0 +1,444 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2015 Joyent, Inc.
+ */
+
+/*
+ * Take the error number definitions from a foreign system and generate a
+ * translation table that converts illumos native error numbers to foreign
+ * system error numbers.
+ */
+
+#include <ctype.h>
+#include <stdlib.h>
+#include <stdio.h>
+#include <unistd.h>
+#include <errno.h>
+#include <err.h>
+#include <sys/sysmacros.h>
+#include <libcmdutils.h>
+#include <libnvpair.h>
+
+nvlist_t *native_errors;
+nvlist_t *foreign_errors;
+
+struct override {
+	const char *ovr_from;
+	const char *ovr_to;
+} overrides[] = {
+	{ "ENOTSUP", "ENOSYS" },
+	{ 0 }
+};
+
+static const char *
+lookup_override(const char *from)
+{
+	int i;
+
+	for (i = 0; overrides[i].ovr_from != NULL; i++) {
+		if (strcmp(overrides[i].ovr_from, from) == 0) {
+			return (overrides[i].ovr_to);
+		}
+	}
+
+	return (NULL);
+}
+
+static int
+parse_int(const char *number, int *rval)
+{
+	long n;
+	char *endpos;
+
+	errno = 0;
+	if ((n = strtol(number, &endpos, 10)) == 0 && errno != 0) {
+		return (-1);
+	}
+
+	if (endpos != NULL && *endpos != '\0') {
+		errno = EINVAL;
+		return (-1);
+	}
+
+	if (n > INT_MAX || n < INT_MIN) {
+		errno = EOVERFLOW;
+		return (-1);
+	}
+
+	*rval = (int)n;
+	return (0);
+}
+
+static int
+errnum_add(nvlist_t *nvl, const char *name, const char *number)
+{
+	int val;
+
+	if (nvlist_exists(nvl, name)) {
+		(void) fprintf(stderr, "ERROR: duplicate definition: %s -> "
+		    "%s\n", name, number);
+		errno = EEXIST;
+		return (-1);
+	}
+
+	/*
+	 * Try and parse the error number:
+	 */
+	if (parse_int(number, &val) == 0) {
+		/*
+		 * The name refers to a number.
+		 */
+		if (nvlist_add_int32(nvl, name, val) != 0) {
+			(void) fprintf(stderr, "ERROR: nvlist_add_int32: %s\n",
+			    strerror(errno));
+			return (-1);
+		}
+	} else {
+		/*
+		 * The name refers to another definition.
+		 */
+		if (nvlist_add_string(nvl, name, number) != 0) {
+			(void) fprintf(stderr, "ERROR: nvlist_add_string: %s\n",
+			    strerror(errno));
+			return (-1);
+		}
+	}
+
+	return (0);
+}
+
+static int
+errnum_max(nvlist_t *nvl)
+{
+	int max = 0;
+	nvpair_t *nvp = NULL;
+
+	while ((nvp = nvlist_next_nvpair(nvl, nvp)) != NULL) {
+		if (nvpair_type(nvp) != DATA_TYPE_INT32) {
+			continue;
+		}
+
+		max = MAX(fnvpair_value_int32(nvp), max);
+	}
+
+	return (max);
+}
+
+static int
+errname_by_num(nvlist_t *nvl, int num, const char **name)
+{
+	nvpair_t *nvp = NULL;
+
+	while ((nvp = nvlist_next_nvpair(nvl, nvp)) != NULL) {
+		if (nvpair_type(nvp) != DATA_TYPE_INT32) {
+			continue;
+		}
+
+		if (fnvpair_value_int32(nvp) == num) {
+			*name = nvpair_name(nvp);
+			return (0);
+		}
+	}
+
+	errno = ENOENT;
+	return (-1);
+}
+
+static int
+errno_by_name(nvlist_t *nvl, const char *name, int *rval, const char **rname)
+{
+	nvpair_t *nvp = NULL;
+
+	if (nvlist_lookup_nvpair(nvl, name, &nvp) != 0) {
+		errno = ENOENT;
+		return (-1);
+	}
+
+	if (nvpair_type(nvp) == DATA_TYPE_STRING) {
+		return (errno_by_name(nvl, fnvpair_value_string(nvp), rval,
+		    rname));
+	} else {
+		*rval = fnvpair_value_int32(nvp);
+		if (rname != NULL) {
+			*rname = name;
+		}
+		return (0);
+	}
+}
+
+static int
+process_line(const char *line, nvlist_t *nvl)
+{
+	custr_t *nam = NULL, *num = NULL;
+	const char *c = line;
+
+	if (custr_alloc(&nam) != 0 || custr_alloc(&num) != 0) {
+		int en = errno;
+
+		custr_free(nam);
+		custr_free(num);
+
+		errno = en;
+		return (-1);
+	}
+
+	/*
+	 * Valid lines begin with "#define":
+	 */
+	if (*c++ != '#' || *c++ != 'd' || *c++ != 'e' || *c++ != 'f' ||
+	    *c++ != 'i' || *c++ != 'n' || *c++ != 'e') {
+		return (0);
+	}
+
+	/*
+	 * Eat whitespace:
+	 */
+	for (;;) {
+		if (*c == '\0') {
+			return (0);
+		}
+
+		if (*c != ' ' && *c != '\t') {
+			break;
+		}
+
+		c++;
+	}
+
+	/*
+	 * Read error number token:
+	 */
+	for (;;) {
+		if (*c == '\0') {
+			return (0);
+		}
+
+		if (*c == ' ' || *c == '\t') {
+			break;
+		}
+
+		if (custr_appendc(nam, *c) != 0) {
+			return (-1);
+		}
+
+		c++;
+	}
+
+	/*
+	 * Eat whitespace:
+	 */
+	for (;;) {
+		if (*c == '\0') {
+			return (0);
+		}
+
+		if (*c != ' ' && *c != '\t') {
+			break;
+		}
+
+		c++;
+	}
+
+	/*
+	 * Read error number token:
+	 */
+	for (;;) {
+		if (*c == '\0') {
+			break;
+		}
+
+		if (*c == ' ' || *c == '\t') {
+			break;
+		}
+
+		if (custr_appendc(num, *c) != 0) {
+			return (-1);
+		}
+
+		c++;
+	}
+
+	return (errnum_add(nvl, custr_cstr(nam), custr_cstr(num)));
+}
+
+static int
+read_file_into_list(const char *path, nvlist_t *nvl)
+{
+	int rval = 0, en = 0;
+	FILE *f;
+	custr_t *cu = NULL;
+
+	if (custr_alloc(&cu) != 0) {
+		return (-1);
+	}
+
+	if ((f = fopen(path, "r")) == NULL) {
+		custr_free(cu);
+		return (-1);
+	}
+
+	for (;;) {
+		int c;
+
+		errno = 0;
+		switch (c = fgetc(f)) {
+		case '\n':
+		case EOF:
+			if (errno != 0) {
+				en = errno;
+				rval = -1;
+				goto out;
+			}
+			if (process_line(custr_cstr(cu), nvl) != 0) {
+				en = errno;
+				rval = -1;
+				goto out;
+			}
+			custr_reset(cu);
+			if (c == EOF) {
+				goto out;
+			}
+			break;
+
+		case '\r':
+		case '\0':
+			/*
+			 * Ignore these characters.
+			 */
+			break;
+
+		default:
+			if (custr_appendc(cu, c) != 0) {
+				en = errno;
+				rval = -1;
+				goto out;
+			}
+			break;
+		}
+	}
+
+out:
+	(void) fclose(f);
+	custr_free(cu);
+	errno = en;
+	return (rval);
+}
+
+int
+main(int argc, char **argv)
+{
+	int max;
+	int fval;
+	int c;
+
+	if (nvlist_alloc(&native_errors, NV_UNIQUE_NAME, 0) != 0 ||
+	    nvlist_alloc(&foreign_errors, NV_UNIQUE_NAME, 0) != 0) {
+		err(1, "could not allocate memory");
+	}
+
+	while ((c = getopt(argc, argv, ":N:F:")) != -1) {
+		switch (c) {
+		case 'N':
+			if (read_file_into_list(optarg, native_errors) != 0) {
+				err(1, "could not read file: %s", optarg);
+			}
+			break;
+
+		case 'F':
+			if (read_file_into_list(optarg, foreign_errors) != 0) {
+				err(1, "could not read file: %s", optarg);
+			}
+			break;
+
+		case ':':
+			errx(1, "option -%c requires an operand", c);
+			break;
+
+		case '?':
+			errx(1, "option -%c unrecognised", c);
+			break;
+		}
+	}
+
+	/*
+	 * Print an array entry for each error number:
+	 */
+	max = errnum_max(native_errors);
+	for (fval = 0; fval <= max; fval++) {
+		const char *fname;
+		const char *tname = NULL;
+		int32_t tval;
+		const char *msg = NULL;
+		const char *comma = (fval != max) ? "," : "";
+
+		if (errname_by_num(native_errors, fval, &fname) == -1) {
+			fname = NULL;
+		}
+
+		if (fval == 0) {
+			/*
+			 * The error number "0" is special: it means no worries.
+			 */
+			msg = "No Error";
+			tval = 0;
+		} else if (fname == NULL) {
+			/*
+			 * There is no defined name for this error number; it
+			 * is unused.
+			 */
+			msg = "Unused Number";
+			tval = -1;
+		} else {
+			/*
+			 * Check if we want to override the name of this error
+			 * in the foreign error number lookup:
+			 */
+			const char *oname = lookup_override(fname);
+
+			/*
+			 * Do the lookup:
+			 */
+			if (errno_by_name(foreign_errors, oname != NULL ?
+			    oname : fname, &tval, &tname) != 0) {
+				/*
+				 * There was no foreign error number by that
+				 * name.
+				 */
+				tname = "No Analogue";
+				tval = -2;
+			}
+		}
+
+		if (msg == NULL) {
+			size_t flen = strlen(fname);
+			size_t tlen = strlen(tname);
+			const char *t = flen > 7 ? "\t" : "\t\t";
+			const char *tt = tlen < 7 ? "\t\t\t" : tlen < 15 ?
+			    "\t\t" : "\t";
+
+			(void) fprintf(stdout, "\t%d%s\t/* %3d: %s%s--> %3d: "
+			    "%s%s*/\n", tval, comma, fval, fname, t, tval,
+			    tname, tt);
+		} else {
+			const char *t = "\t\t\t\t\t";
+
+			(void) fprintf(stdout, "\t%d%s\t/* %3d: %s%s*/\n", tval,
+			    comma, fval, msg, t);
+		}
+	}
+
+	(void) nvlist_free(native_errors);
+	(void) nvlist_free(foreign_errors);
+
+	return (0);
+}
--- old/usr/src/common/list/list.c	Wed Oct  5 00:31:45 2016
+++ new/usr/src/common/list/list.c	Wed Oct  5 00:31:45 2016
@@ -38,7 +38,17 @@
 #endif
 
 #ifdef lint
-extern list_node_t *list_d2l(list_t *list, void *obj);
+static list_node_t *
+list_d2l(list_t *list, void *obj)
+{
+	/* Pretty version for lint... */
+	uint64_t *offset = (uint64_t *)obj;
+
+	if (!IS_P2ALIGNED(obj, 8))
+		return (NULL);
+
+	return ((list_node_t *)(offset + (list->list_offset >> 3)));
+}
 #else
 #define	list_d2l(a, obj) ((list_node_t *)(((char *)obj) + (a)->list_offset))
 #endif
